var _jsxFileName = "/var/www/html/formbuilder/src/utils/section/index.js";
import React, { useState } from 'react';
import { connect } from 'react-redux';
import ExpansionPanel from '@material-ui/core/ExpansionPanel';
import ExpansionPanelSummary from '@material-ui/core/ExpansionPanelSummary';
import ExpansionPanelDetails from '@material-ui/core/ExpansionPanelDetails';
import Typography from '@material-ui/core/Typography';
import ExpandMoreIcon from '@material-ui/icons/ExpandMore';
import Divider from '@material-ui/core/Divider';
import Wrapper from '../../components/app/FieldWrapper';
import _ from 'lodash';

function Section(props) {
  var _this = this;

  var name = props.name,
      uuid = props.uuid,
      collapseable = props.collapseable;

  var _useState = useState(true),
      expand = _useState[0],
      setExpand = _useState[1];

  var renderFields = function renderFields() {
    var fields = Object.values(props.data);
    var sectionFields = fields.filter(function (field) {
      if (field.parentId === uuid) return true;
      return false;
    });
    if (!sectionFields.length) return /*#__PURE__*/React.createElement("div", {
      style: {
        textAlign: 'center'
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 23,
        columnNumber: 39
      }
    }, /*#__PURE__*/React.createElement("small", {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 23,
        columnNumber: 74
      }
    }, " Drop fields here"));
    return _.map(sectionFields, function (field, index) {
      return /*#__PURE__*/React.createElement(ExpansionPanelDetails, {
        style: {
          padding: 0
        },
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 26,
          columnNumber: 11
        }
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          width: '100%'
        },
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 27,
          columnNumber: 15
        }
      }, /*#__PURE__*/React.createElement("li", {
        key: 'li-' + field.uuid,
        className: "d-block container-fluid",
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 28,
          columnNumber: 15
        }
      }, /*#__PURE__*/React.createElement(Wrapper, {
        data: field,
        key: field.uuid,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 29,
          columnNumber: 15
        }
      }))));
    });
  };

  var handleChange = function handleChange() {
    if (collapseable) setExpand(!expand);
  };

  return /*#__PURE__*/React.createElement("div", {
    style: {
      marginTop: 10
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 41,
      columnNumber: 5
    }
  }, /*#__PURE__*/React.createElement(ExpansionPanel, {
    elevation: 0,
    onChange: handleChange,
    expanded: expand,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 42,
      columnNumber: 7
    }
  }, /*#__PURE__*/React.createElement(ExpansionPanelSummary, {
    expandIcon: collapseable ? /*#__PURE__*/React.createElement(ExpandMoreIcon, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 48,
        columnNumber: 36
      }
    }) : '',
    "aria-controls": "panel1a-content",
    id: "panel1a-header",
    style: {
      padding: 0
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 47,
      columnNumber: 9
    }
  }, /*#__PURE__*/React.createElement(Typography, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 53,
      columnNumber: 11
    }
  }, name)), expand ? /*#__PURE__*/React.createElement("hr", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 55,
      columnNumber: 18
    }
  }) : '', renderFields()));
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    data: state.form.data,
    order: state.form.order
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setOrder: function (_setOrder) {
      function setOrder(_x) {
        return _setOrder.apply(this, arguments);
      }

      setOrder.toString = function () {
        return _setOrder.toString();
      };

      return setOrder;
    }(function (data) {
      return dispatch(setOrder(data));
    })
  };
};

export default connect(mapStateToProps)(Section);