"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _SimpleTabs = _interopRequireDefault(require("../../../utils/Tabs/SimpleTabs"));

var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));

var _Checkbox = _interopRequireDefault(require("../../../utils/checkboxs/Checkbox"));

var _ValidateField = _interopRequireDefault(require("../../../utils/validations/ValidateField"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _toolbarActions = require("../../../actions/toolbarActions");

var _formActions = require("../../../actions/formActions");

var _reactRedux = require("react-redux");

var _predefinedValues = _interopRequireDefault(require("../../../utils/predefined-values"));

var _choices = _interopRequireDefault(require("../../../utils/choices"));

var _conditionalLogic = _interopRequireDefault(require("../../../utils/conditional-logic"));

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _axios = _interopRequireDefault(require("axios"));

var _predefinedActions = require("../../../actions/predefinedActions");

var _SearchableSelect = _interopRequireDefault(require("../../../utils/selects/SearchableSelect"));

var _helpers = require("../../../utils/helpers");

var _FieldRenderer = _interopRequireDefault(require("./utils/FieldRenderer"));

var _checkboxFieldConfigs = require("./utils/checkboxFieldConfigs");

var _helpers2 = require("./utils/helpers");

var _jsxFileName = "/var/www/html/formbuilder/src/components/toolbar/field-forms/Checkbox.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var basicTabTitle = {
  en: 'Basic Settings',
  ar: 'الإعدادات الأساسية'
};
var advanceTabTitle = {
  en: 'Advance Settings',
  ar: 'إعدادات متقدمة'
};
var machineNameLabel = {
  en: 'Machine Name/Field ID',
  ar: 'إسم الألة'
};
var visibilityLabel = {
  en: 'Visibility to Employee',
  ar: 'الرؤية للموظف'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var saveLabel = {
  en: 'Save',
  ar: 'حفظ'
};
var choiceLabel = {
  en: 'Choices',
  ar: 'خيارات'
};
var enableOtherChoiceLabel = {
  en: 'Enable "Other" Choice',
  ar: 'تمكين خيار آخر'
};
var visibleLabel = {
  en: 'Visible',
  ar: 'مرئي'
};
var hiddenLabel = {
  en: 'Hidden',
  ar: 'مختفي'
};

var CustomCheckbox = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(CustomCheckbox, _React$Component);

  function CustomCheckbox(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleTabChange", function (e, newValue) {
      _this.setState({
        activeTab: newValue
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleDataChange", function (val, name) {
      var _this$setState;

      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState));
    });

    _defineProperty(_assertThisInitialized(_this), "saveField", function () {
      var _this$state = _this.state,
          name = _this$state.name,
          machineName = _this$state.machineName,
          order = _this$state.order,
          conditionalLogic = _this$state.conditionalLogic,
          isRequired = _this$state.isRequired,
          placeholder = _this$state.placeholder,
          helpText = _this$state.helpText,
          subType = _this$state.subType,
          visibility = _this$state.visibility,
          uuid = _this$state.uuid,
          type = _this$state.type,
          optionReferenceId = _this$state.optionReferenceId,
          enableOther = _this$state.enableOther,
          parentId = _this$state.parentId;
      var newField = {
        name: name,
        machineName: machineName,
        order: order,
        uuid: uuid,
        type: type,
        parentId: parentId,
        config: {
          conditionalLogic: conditionalLogic,
          isConditionalEnabled: !!conditionalLogic.conditions.length,
          isRequired: isRequired,
          placeholder: placeholder,
          helpText: helpText,
          subType: subType,
          visibility: visibility,
          optionReferenceId: optionReferenceId,
          enableOther: enableOther
        }
      };
      newField.locals = (0, _helpers2.processLocalFields)(_this.props.locals, _this.state);
      (0, _ValidateField["default"])(newField, null, _this.props.currentLang).then(function () {
        _this.props.updateField(newField);

        _this.props.disableFieldEdit();
      })["catch"](function (errors) {
        var keys = Object.keys(errors);

        if (keys[0] === 'machineName' || keys[0] === 'conditionalLogic') {
          _this.handleTabChange({}, 'advance');
        } else {
          _this.handleTabChange({}, 'basic');
        }

        _this.setState({
          errors: errors
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cancelEdit", function () {
      _this.props.deleteNewField();

      _this.props.disableFieldEdit();
    });

    _defineProperty(_assertThisInitialized(_this), "updateChoices", function (options) {
      _this.setState({
        options: options
      });
    });

    _defineProperty(_assertThisInitialized(_this), "insertChoices", function (id) {
      if (_this.state.optionReferenceId) {
        _axios["default"].post(_this.props.predefinedEndpoint + "/insert-predefine", {
          optionReferenceId: _this.state.optionReferenceId,
          predefinedOptRefId: id
        }).then(function (res) {
          _this.props.updateCategoryOptions(res.data.optionReference.options, res.data.optionReference.slug);
        });
      } else {
        _this.disablePredefined().then(function (res) {
          _axios["default"].post(_this.props.predefinedEndpoint + "/insert-predefine", {
            optionReferenceId: _this.state.optionReferenceId,
            predefinedOptRefId: id
          }).then(function (response) {
            _this.props.updateCategoryOptions(response.data.optionReference.options, response.data.optionReference.slug);
          });
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "disablePredefined", function () {
      return new Promise(function (resolve, reject) {
        var options = [];

        for (var i = 0; i < _this.props.predefined.length; i++) {
          if (_this.props.predefined[i].id === _this.state.optionReferenceId) {
            _this.props.predefined[i].options.map(function (option) {
              options.push({
                name: option.name,
                value: option.value
              });
            });

            break;
          }
        }

        _axios["default"].post(_this.props.predefinedEndpoint, {
          name: _this.state.machineName,
          slug: _this.state.machineName,
          isPublic: false,
          options: options
        }).then(function (res) {
          _this.props.addCategory(res.data);

          _this.setState({
            optionReferenceId: res.data.id
          }, function () {
            resolve(res.data);
          });
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderTabFields", function () {
      if (_this.state.activeTab === 'basic') {
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 186,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement(_FieldRenderer["default"], _extends({}, _this.state, {
          locals: _this.props.locals,
          fieldConfigs: _checkboxFieldConfigs.checkboxFieldsConfigs,
          handleDataChange: _this.handleDataChange,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 187,
            columnNumber: 11
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 204,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_choices["default"], {
          disablePredefined: _this.disablePredefined,
          predefined: _this.props.predefined,
          optionReferenceId: _this.state.optionReferenceId,
          required: true,
          label: choiceLabel[_this.props.currentLang],
          updateChoices: _this.updateChoices,
          choices: _this.state.options,
          error: _this.state.errors.options,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 205,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement(_predefinedValues["default"], {
          insertChoices: _this.insertChoices,
          selected: _this.state.optionReferenceId,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 207,
            columnNumber: 11
          }
        }), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 208,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          checked: _this.state.enableOther,
          handleChange: function handleChange(val) {
            return _this.handleDataChange(val, 'enableOther');
          },
          label: enableOtherChoiceLabel[_this.props.currentLang],
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 209,
            columnNumber: 13
          }
        })));
      } else {
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 215,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 216,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.machineName,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'machineName');
          },
          label: machineNameLabel[_this.props.currentLang],
          required: true,
          autoFocus: true,
          error: _this.state.errors.machineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 217,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 219,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
          options: [{
            label: visibleLabel[_this.props.currentLang],
            value: 'visible'
          }, {
            label: hiddenLabel[_this.props.currentLang],
            value: 'hidden'
          }],
          label: visibilityLabel[_this.props.currentLang],
          value: _this.state.visibility ? 'visible' : 'hidden',
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value === 'visible', 'visibility');
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 220,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement(_conditionalLogic["default"], {
          conditionalLogic: _this.state.conditionalLogic,
          isConditionalEnabled: _this.state.isConditionalEnabled,
          handleChange: _this.handleDataChange,
          errors: _this.state.errors.conditionalLogic ? _this.state.errors.conditionalLogic : [],
          predefined: _this.props.predefined,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 222,
            columnNumber: 11
          }
        }));
      }
    });

    _this.state = _extends({
      activeTab: 'basic',
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName
    }, props.data.config);
    return _this;
  }

  var _proto = CustomCheckbox.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        activeTab: 'basic',
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        type: nextProps.data.type,
        order: nextProps.data.order,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName
      }, nextProps.data.config));
    }
  };

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 230,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement(_SimpleTabs["default"], {
      value: this.state.activeTab,
      handleChange: this.handleTabChange,
      options: [{
        label: basicTabTitle[this.props.currentLang],
        value: 'basic'
      }, {
        label: advanceTabTitle[this.props.currentLang],
        value: 'advance'
      }],
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 231,
        columnNumber: 9
      }
    }), /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
      style: {
        height: (0, _helpers.getHeight)(true, true)
      },
      autoHide: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 232,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-p-3 ahfb-my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 233,
        columnNumber: 11
      }
    }, this.renderTabFields(), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full ahfb-text-right",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 235,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "outlined",
      color: "primary",
      className: "ahfb-mr-2",
      onClick: this.cancelEdit,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 236,
        columnNumber: 15
      }
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "contained",
      color: "primary",
      disableElevation: true,
      onClick: this.saveField,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 239,
        columnNumber: 15
      }
    }, saveLabel[this.props.currentLang])))));
  };

  return CustomCheckbox;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    locals: state.form.locals,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    deleteNewField: function deleteNewField() {
      return dispatch((0, _formActions.deleteNewField)());
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    updateField: function updateField(data) {
      return dispatch((0, _formActions.updateField)(data));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    },
    addCategory: function addCategory(id) {
      return dispatch((0, _predefinedActions.addCategory)(id));
    },
    updateCategoryOptions: function updateCategoryOptions(data, slug) {
      return dispatch((0, _predefinedActions.updateCategoryOptions)(data, slug));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(CustomCheckbox);

exports["default"] = _default;
module.exports = exports.default;