"use strict";

exports.__esModule = true;
exports["default"] = NewOption;

var _react = _interopRequireWildcard(require("react"));

var _TextInput = _interopRequireDefault(require("../inputs/TextInput"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));

var _helpers = require("../helpers");

var _core = require("@material-ui/core");

var _jsxFileName = "/var/www/html/formbuilder/src/utils/predefined-values/NewOption.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function NewOption(props) {
  var _React$useState = _react["default"].useState(''),
      name = _React$useState[0],
      setName = _React$useState[1];

  var _React$useState2 = _react["default"].useState(''),
      value = _React$useState2[0],
      setValue = _React$useState2[1];

  var _React$useState3 = _react["default"].useState(''),
      updated = _React$useState3[0],
      setUpdated = _React$useState3[1];

  var _React$useState4 = _react["default"].useState(''),
      error = _React$useState4[0],
      setError = _React$useState4[1];

  var inputRef = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    var _inputRef$current;

    inputRef == null ? void 0 : (_inputRef$current = inputRef.current) == null ? void 0 : _inputRef$current.focus();
  }, []);

  var handleNameChange = function handleNameChange(e) {
    setError('');
    setName(e.target.value);
  };

  var handleValueChange = function handleValueChange(e) {
    setError('');
    setValue(e.target.value);
  };

  var saveNewOption = function saveNewOption(e) {
    var _inputRef$current2;

    e.preventDefault();
    var values = [];
    var properValue = value;

    if (!value || value === '') {
      properValue = (0, _helpers.stringToSlug)(name);
    }

    props.options.map(function (option) {
      values.push(option.name);
    });

    if (values.includes(name)) {
      setError('Category with same name already exists.');
    } else {
      props.saveNewCategoryOption(name, properValue);
      setName('');
      setValue('');
    }

    inputRef == null ? void 0 : (_inputRef$current2 = inputRef.current) == null ? void 0 : _inputRef$current2.focus();
  };

  return /*#__PURE__*/_react["default"].createElement("form", {
    onSubmit: saveNewOption,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 49,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    className: "ahfb-pl-3",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 50,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    xs: 6,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 51,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    inputProps: {
      ref: inputRef
    },
    placeholder: "Name",
    value: name,
    handleChange: handleNameChange,
    error: error,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 52,
      columnNumber: 11
    }
  })), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    className: "ahfb-pl-2",
    item: true,
    xs: 6,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 60,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    placeholder: "Value",
    value: value,
    handleChange: handleValueChange,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 61,
      columnNumber: 11
    }
  }))), /*#__PURE__*/_react["default"].createElement("button", {
    className: "ahfb-hidden",
    type: "submit",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 68,
      columnNumber: 7
    }
  }, "Submit"));
}

module.exports = exports.default;