"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Dialog = _interopRequireDefault(require("@material-ui/core/Dialog"));

var _DialogActions = _interopRequireDefault(require("@material-ui/core/DialogActions"));

var _DialogContent = _interopRequireDefault(require("@material-ui/core/DialogContent"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _reactDraggable = _interopRequireDefault(require("react-draggable"));

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _ListItemSecondaryAction = _interopRequireDefault(require("@material-ui/core/ListItemSecondaryAction"));

var _core = require("@material-ui/core");

var _Snackbar = _interopRequireDefault(require("@material-ui/core/Snackbar"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _Add = _interopRequireDefault(require("@material-ui/icons/Add"));

var _Close = _interopRequireDefault(require("@material-ui/icons/Close"));

var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));

var _lodash = _interopRequireDefault(require("lodash"));

var _axios = _interopRequireDefault(require("axios"));

var _reactRedux = require("react-redux");

require("./style.scss");

var _NewCategory = _interopRequireDefault(require("./NewCategory"));

var _predefinedActions = require("../../actions/predefinedActions");

var _helpers = require("../helpers");

var _NewOption = _interopRequireDefault(require("./NewOption"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _jsxFileName = "/var/www/html/formbuilder/src/utils/predefined-values/index.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var addLabel = {
  en: 'Add Predefined Values',
  ar: 'أضف قيمًا محددة مسبقًا'
};
var categoryLabel = {
  en: 'Category',
  ar: 'الفئة'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var insertLabel = {
  en: 'Insert Choices',
  ar: 'أدخل الاختيارات'
};
var noPredefinedLabel = {
  en: 'There are no predefined categories available.',
  ar: 'لا توجد فئات محددة مسبقا متاحة'
};
var noOptionsLabel = {
  en: 'No options available',
  ar: 'لا توجد خيارات متاحة'
};
var createNewOptionsLabel = {
  en: 'Start Creating new options',
  ar: 'ابدأ في إنشاء خيارات جديدة'
};
var viewOptionsLabel = {
  en: 'Select a category to view its options',
  ar: 'حدد فئة لعرض خياراتها'
};
var newCategoryLabel = {
  en: 'New category successfully added.',
  ar: 'تمت إضافة فئة جديدة بنجاح'
};
var divisionLabel = {
  en: 'Divisions',
  ar: 'الانقسامات'
};
var jobTitleLabel = {
  en: 'Job Title',
  ar: 'مسمى وظيفي'
};
var locationLabel = {
  en: 'Locations',
  ar: 'المواقع'
};

function PaperComponent(props) {
  return /*#__PURE__*/_react["default"].createElement(_reactDraggable["default"], {
    handle: "#draggable-dialog-title",
    cancel: '[class*="MuiDialogContent-root"]',
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 86,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(_Paper["default"], _extends({}, props, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 87,
      columnNumber: 7
    }
  })));
}

var PredefinedValues = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(PredefinedValues, _React$Component);

  function PredefinedValues(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleAddCategoryMsgClose", function () {
      _this.setState({
        showAddCategoryMsg: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClickOpen", function () {
      _this.setState({
        open: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function () {
      _this.setState({
        open: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleInsert", function () {
      if (_this.state.activeCategory) {
        _this.props.insertChoices(_this.state.activeCategory.id);

        _this.handleClose();
      } else {
        _this.setState({
          insertError: {
            en: "Select a category to insert options",
            ar: 'حدد فئة لعرض خياراتها'
          }
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "enableCategory", function (category) {
      _this.setState({
        activeCategory: category,
        insertError: null
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleAddCategoryOpen", function () {
      _this.setState({
        addCategory: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleAddCategoryClose", function () {
      _this.setState({
        addCategory: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "saveNewCategory", function (categoryName) {
      var slug = (0, _helpers.stringToSlug)(categoryName);
      var data = {
        options: [],
        label: categoryName
      };

      _axios["default"].post(_this.props.predefinedEndpoint, {
        name: categoryName,
        slug: slug,
        isPublic: true
      }).then(function (res) {
        _this.props.addCategory(res.data);

        _this.setState({
          addCategory: false,
          showAddCategoryMsg: true
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "saveNewCategoryOption", function (name, value) {
      _axios["default"].post(_this.props.predefinedEndpoint + '/' + _this.state.activeCategory.id + '/options', {
        name: name,
        value: value
      }).then(function (res) {
        _this.props.updateCategoryOptions(res.data.options, _this.state.activeCategory.slug);

        _this.setState({
          activeCategory: _extends({}, _this.state.activeCategory, {
            options: res.data.options
          })
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "deleteOption", function (option) {
      _axios["default"]["delete"](_this.props.predefinedEndpoint + '/' + _this.state.activeCategory.id + '/options/' + option.id).then(function (res) {
        _this.props.updateCategoryOptions(res.data.options, _this.state.activeCategory.slug);

        _this.setState({
          activeCategory: _extends({}, _this.state.activeCategory, {
            options: res.data.options
          })
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderAddCategory", function () {
      if (_this.state.addCategory) {
        return /*#__PURE__*/_react["default"].createElement(_NewCategory["default"], {
          currentLang: _this.props.currentLang,
          names: _lodash["default"].map(_this.props.predefined, function (item) {
            return item.name.toLowerCase();
          }),
          saveNewCategory: _this.saveNewCategory,
          handleAddCategoryClose: _this.handleAddCategoryClose,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 207,
            columnNumber: 9
          }
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderAddOption", function () {
      if (_this.state.activeCategory && !_this.state.activeCategory.is_secure) {
        return /*#__PURE__*/_react["default"].createElement(_NewOption["default"], {
          saveNewCategoryOption: _this.saveNewCategoryOption,
          options: _this.state.activeCategory.options,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 215,
            columnNumber: 9
          }
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderCategories", function () {
      if (_lodash["default"].size(_this.props.predefined)) {
        return _lodash["default"].map(_this.props.predefined, function (category) {
          if (category.is_public) {
            if (category.name === 'Divisions') {
              return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
                key: 'category-' + category.slug,
                button: true,
                selected: _this.state.activeCategory && _this.state.activeCategory.slug === category.slug,
                onClick: function onClick(e) {
                  return _this.enableCategory(category);
                },
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 226,
                  columnNumber: 15
                }
              }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
                primary: divisionLabel[_this.props.currentLang],
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 227,
                  columnNumber: 17
                }
              }));
            } else if (category.name === 'Job Titles') {
              return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
                key: 'category-' + category.slug,
                button: true,
                selected: _this.state.activeCategory && _this.state.activeCategory.slug === category.slug,
                onClick: function onClick(e) {
                  return _this.enableCategory(category);
                },
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 232,
                  columnNumber: 15
                }
              }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
                primary: jobTitleLabel[_this.props.currentLang],
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 233,
                  columnNumber: 17
                }
              }));
            } else if (category.name === 'Locations') {
              return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
                key: 'category-' + category.slug,
                button: true,
                selected: _this.state.activeCategory && _this.state.activeCategory.slug === category.slug,
                onClick: function onClick(e) {
                  return _this.enableCategory(category);
                },
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 238,
                  columnNumber: 15
                }
              }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
                primary: locationLabel[_this.props.currentLang],
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 239,
                  columnNumber: 17
                }
              }));
            } else {
              return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
                key: 'category-' + category.slug,
                button: true,
                selected: _this.state.activeCategory && _this.state.activeCategory.slug === category.slug,
                onClick: function onClick(e) {
                  return _this.enableCategory(category);
                },
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 244,
                  columnNumber: 15
                }
              }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
                primary: category.name,
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 245,
                  columnNumber: 17
                }
              }));
            }
          }
        });
      } else {
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 253,
            columnNumber: 9
          }
        }, noPredefinedLabel[_this.props.currentLang]);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderCategoryOptions", function () {
      if (_this.state.activeCategory) {
        if (_this.state.activeCategory.options && _this.state.activeCategory.options.length) {
          var options = _this.state.activeCategory.options;
          var labelProp = 'name';
          var valueProp = 'value';
          return options.map(function (option) {
            return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
              key: option.id,
              __self: _assertThisInitialized(_this),
              __source: {
                fileName: _jsxFileName,
                lineNumber: 266,
                columnNumber: 13
              }
            }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
              primary: option[labelProp],
              __self: _assertThisInitialized(_this),
              __source: {
                fileName: _jsxFileName,
                lineNumber: 267,
                columnNumber: 15
              }
            }), !_this.state.activeCategory.is_secure ? /*#__PURE__*/_react["default"].createElement(_ListItemSecondaryAction["default"], {
              __self: _assertThisInitialized(_this),
              __source: {
                fileName: _jsxFileName,
                lineNumber: 271,
                columnNumber: 17
              }
            }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
              edge: "end",
              "aria-label": "delete",
              onClick: function onClick(e) {
                return _this.deleteOption(option);
              },
              __self: _assertThisInitialized(_this),
              __source: {
                fileName: _jsxFileName,
                lineNumber: 272,
                columnNumber: 19
              }
            }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], {
              __self: _assertThisInitialized(_this),
              __source: {
                fileName: _jsxFileName,
                lineNumber: 273,
                columnNumber: 21
              }
            }))) : "");
          });
        } else if (_this.state.activeCategory.is_secure) {
          return /*#__PURE__*/_react["default"].createElement("span", {
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 282,
              columnNumber: 11
            }
          }, noOptionsLabel[_this.props.currentLang]);
        } else {
          return /*#__PURE__*/_react["default"].createElement("span", {
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 288,
              columnNumber: 11
            }
          }, createNewOptionsLabel[_this.props.currentLang]);
        }
      } else {
        return /*#__PURE__*/_react["default"].createElement("span", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 295,
            columnNumber: 9
          }
        }, viewOptionsLabel[_this.props.currentLang]);
      }
    });

    var active = null;

    if (props.selected) {
      for (var i = 0; i < props.predefined.length; i++) {
        if (props.predefined[i].id === _this.props.selected) {
          active = props.predefined[i];
          break;
        }
      }
    }

    _this.state = {
      open: false,
      activeCategory: active,
      addCategory: false,
      newCategoryName: '',
      showAddCategoryMsg: false,
      insertError: null
    };
    return _this;
  }

  var _proto = PredefinedValues.prototype;

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 304,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full ahfb-text-right",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 305,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      color: "primary",
      onClick: this.handleClickOpen,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 306,
        columnNumber: 11
      }
    }, this.state.activeCategory && this.state.activeCategory.isPublic ? /*#__PURE__*/_react["default"].createElement(_Done["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 306,
        columnNumber: 136
      }
    }) : "", " ", addLabel[this.props.currentLang])), /*#__PURE__*/_react["default"].createElement(_Dialog["default"], {
      open: this.state.open,
      onClose: this.handleClose,
      PaperComponent: PaperComponent,
      "aria-labelledby": "draggable-dialog-title",
      maxWidth: "xl",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 308,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement(_AppBar["default"], {
      className: "ahfb-position-relative",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 315,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 316,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
      variant: "h6",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 317,
        columnNumber: 15
      }
    }, addLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      className: "ahfb-position-absolute ahfb-shift-right",
      color: "inherit",
      onClick: this.handleClose,
      "aria-label": "close",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 320,
        columnNumber: 15
      }
    }, /*#__PURE__*/_react["default"].createElement(_Close["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 321,
        columnNumber: 17
      }
    })))), /*#__PURE__*/_react["default"].createElement(_DialogContent["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 325,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
      container: true,
      className: "ahfb-dialog-content-root",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 326,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
      item: true,
      xs: 5,
      className: "ahfb-pr-1 ahfb-categories-list-container",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 327,
        columnNumber: 15
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-position-relative",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 328,
        columnNumber: 17
      }
    }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
      variant: "h6",
      component: "h6",
      className: "ahfb-categories-add-heading",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 329,
        columnNumber: 19
      }
    }, /*#__PURE__*/_react["default"].createElement("span", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 330,
        columnNumber: 21
      }
    }, categoryLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_core.Tooltip, {
      title: "Add a new category",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 331,
        columnNumber: 21
      }
    }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      onClick: this.handleAddCategoryOpen,
      className: "ahfb-categories-add-icon " + (this.props.currentLang === 'ar' ? 'ahfb-width-50' : ''),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 332,
        columnNumber: 23
      }
    }, /*#__PURE__*/_react["default"].createElement(_Add["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 333,
        columnNumber: 25
      }
    }))))), this.renderAddCategory(), /*#__PURE__*/_react["default"].createElement(_List["default"], {
      className: "ahfb-categories-list",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 339,
        columnNumber: 17
      }
    }, this.renderCategories())), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
      item: true,
      xs: 7,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 343,
        columnNumber: 15
      }
    }, /*#__PURE__*/_react["default"].createElement(_List["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 344,
        columnNumber: 17
      }
    }, this.renderCategoryOptions(), this.renderAddOption()))), !!this.state.insertError ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
      error: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 351,
        columnNumber: 15
      }
    }, this.state.insertError[this.props.currentLang]) : ""), /*#__PURE__*/_react["default"].createElement(_DialogActions["default"], {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 354,
        columnNumber: 11
      }
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      autoFocus: true,
      onClick: this.handleClose,
      color: "primary",
      variant: "outlined",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 355,
        columnNumber: 13
      }
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      onClick: this.handleInsert,
      variant: "contained",
      color: "primary",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 358,
        columnNumber: 13
      }
    }, insertLabel[this.props.currentLang]))), /*#__PURE__*/_react["default"].createElement(_Snackbar["default"], {
      anchorOrigin: {
        vertical: 'bottom',
        horizontal: 'left'
      },
      open: this.state.showAddCategoryMsg,
      autoHideDuration: 6000,
      onClose: this.handleAddCategoryMsgClose,
      message: newCategoryLabel[this.props.currentLang],
      action: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 373,
          columnNumber: 13
        }
      }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        size: "small",
        "aria-label": "close",
        color: "inherit",
        onClick: this.handleAddCategoryMsgClose,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 374,
          columnNumber: 15
        }
      }, /*#__PURE__*/_react["default"].createElement(_Close["default"], {
        fontSize: "small",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 375,
          columnNumber: 17
        }
      }))),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 363,
        columnNumber: 9
      }
    }));
  };

  return PredefinedValues;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    addCategory: function addCategory(data) {
      return dispatch((0, _predefinedActions.addCategory)(data));
    },
    updateCategoryOptions: function updateCategoryOptions(data, slug) {
      return dispatch((0, _predefinedActions.updateCategoryOptions)(data, slug));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(PredefinedValues);

exports["default"] = _default;
module.exports = exports.default;