"use strict";

exports.__esModule = true;
exports["default"] = CustomRadioGroup;

var _react = _interopRequireDefault(require("react"));

var _styles = require("@material-ui/core/styles");

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _lodash = _interopRequireDefault(require("lodash"));

var _RadioGroup = _interopRequireDefault(require("@material-ui/core/RadioGroup"));

var _Radio = _interopRequireDefault(require("@material-ui/core/Radio"));

var _jsxFileName = "/var/www/html/formbuilder/src/utils/radio/RadioGroup.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function CustomRadioGroup(props) {
  var _this = this;

  var options = props.options,
      value = props.value,
      handleChange = props.handleChange,
      label = props.label,
      error = props.error,
      required = props.required,
      helperText = props.helperText,
      disabled = props.disabled;
  var labelProp = props.labelProp ? props.labelProp : 'label';
  var valueProp = props.valueProp ? props.valueProp : 'value';
  return /*#__PURE__*/_react["default"].createElement(_FormControl["default"], {
    required: required,
    error: error,
    component: "fieldset",
    disabled: disabled,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 17,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], {
    component: "label",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 18,
      columnNumber: 7
    }
  }, label), /*#__PURE__*/_react["default"].createElement(_RadioGroup["default"], {
    value: value,
    onChange: handleChange,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 19,
      columnNumber: 7
    }
  }, options.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], {
      key: 'option-' + option[valueProp],
      control: /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
        color: "primary",
        value: option[valueProp],
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 23,
          columnNumber: 15
        }
      }),
      label: option[labelProp],
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 21,
        columnNumber: 11
      }
    });
  })), /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 29,
      columnNumber: 7
    }
  }, error ? error : helperText ? helperText : ''));
}

module.exports = exports.default;